#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}"  "${module}"  "mount ok"
#"1"   "2"   "${dir}"  "${module}"  "partiton lost"
#"2"   "0"   "${dir}"  "${module}"  "readonly"
#"2"   "1"   "${dir}"  "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_LOG_HOME="${BIGDATA_LOG_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_LOG_HOME="$(su - omm -c 'echo $BIGDATA_LOG_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_LOG_HOME}" ]; then
    DISKMGT_BIGDATA_LOG_HOME="/var/log/Bigdata"
fi

DISK_CONFIG_DIR="${DISKMGT_BIGDATA_HOME}/tmp/disk_manager"
DISABLE_DIR_LIST="${DISK_CONFIG_DIR}/disable_dir_list"

LOGFILE="${DISKMGT_BIGDATA_LOG_HOME}/nodeagent/scriptlog/disk_manager_notify.log"


function LOG()
{
    local log_size=0

    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown omm:wheel "$LOGFILE"
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        chown omm:wheel ${LOGFILE}_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"

    if [ ! -d "${DISK_CONFIG_DIR}" ]; then
        mkdir -p ${DISK_CONFIG_DIR}
        chown omm:wheel ${DISK_CONFIG_DIR}
        LOG "INFO" "Set ${DISK_CONFIG_DIR} files permission is $(ls -ld ${DISK_CONFIG_DIR})"
    fi

    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

function restart_datanode()
{
    local pid=""

    #ɱdatanodẹöʱdatanode
    pid=$(ps -efww | grep proc_datanode | grep java |grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find datanode process."
        return 0
    fi

    LOG "INFO" "Kill datanode process, pid=[${pid}]."
    sudo /bin/kill -9 ${pid}
}

function stop_impalad()
{
    local pid=""

    #ɱimpalaḍöʱimpalad
    pid=$(ps -efww | grep "impala-huawei/usr/bin/impalad" | grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find impalad process."
        return 0
    fi

    LOG "INFO" "Kill impalad process, pid=[${pid}]."
    sudo /bin/kill -9 ${pid}
}

# judge is impalad scratch dir configurated on lost or recovery directory
# 1: impala impalad scratch dir configurated on it
# 0: impala impalad scratch dir did not configurated on it
function judge_action()
{
        find ${DISKMGT_BIGDATA_HOME}/FusionInsight/etc/*_*_Impalad/ENV_VARS | xargs cat | grep "IMPALA_SCRATCH_DIR" | grep "${ALARM_DIR}" >> /dev/null
        if [ $? -eq 0 ] ; then
             return 1
        else
             return 0
        fi
}

################################
#impalaĿ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_impala_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

        `judge_action`

         if [ $? -eq 1 ] ; then

                #ñ־ָimpalad
                echo 0 > ${DISABLE_IMPALAD}
                chown omm:wheel ${DISABLE_IMPALAD}
                LOG "INFO" "Recover sign for impalad Set ${DISABLE_IMPALAD} files permission is $(ls -ld ${DISABLE_IMPALAD})"
                #stop impalad
                stop_impalad
         fi

    return 0
}

################################
#impalaĿ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_impala_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

        `judge_action`

        if [ $? -eq 1 ] ; then

            #ñ־ֹimpalad
            echo 1 > ${DISABLE_IMPALAD}
            chown omm:wheel ${DISABLE_IMPALAD}
            LOG "INFO" "Forbidden sign for impalad  Set ${DISABLE_IMPALAD} files permission is $(ls -ld ${DISABLE_IMPALAD})"
            #stop impalad
            stop_impalad
       fi

    return 0
}

# judge is Elk datanode dir configurated on lost or recovery directory
# 1 current alarm directory has Elk data
# 0 current alarm directory does not have Elk data
function judge_Elk_action()
{
    find ${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_ElkServer/install/elk-install-config.xml | xargs cat | grep "${ALARM_DIR}" >> /dev/null
    if [ $? -eq 0 ] ; then
         return 1
    else
         return 0
    fi
}

function handle_Elk_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    judge_Elk_action
    if [ $? -eq 1 ] ; then

        local g_elkInstallPath=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_ElkServer/etc/ENV_VARS | xargs cat | grep "ELK_SOFTWARE_PATH" | awk -F"=" '{print $2}')
        [ -z "$g_elkInstallPath" ] && return 0
            
        # one node just one process to deal 
        isExist=$(ps -ef | grep "${g_elkInstallPath}/package/ELK_MPPDB/script/gs_replace" | grep -v grep)
        if [ -z "$isExist" ];then
            LOG "INFO" "The process gs_replace is not exist, now start it."
            
            ret=$(su - omm -s /bin/bash ${g_elkInstallPath}/sbin/elk-repair.sh)
            if [ $ret -ne 0 ]; then
                LOG "ERROR" "replace node configure failed, result is $?"
                return 1
            fi
        fi
        
    fi

    return 0
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    #ӲĿ¼б޳${ALARM_DIR}
    grep "${ALARM_DIR}" ${DISABLE_DIR_LIST} > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        sed -i "s|^${ALARM_DIR}$||g" ${DISABLE_DIR_LIST}
        sed -i "/^$/d" ${DISABLE_DIR_LIST}
        chown omm:wheel ${DISABLE_DIR_LIST}
        LOG "INFO" "Set ${DISABLE_DIR_LIST} files permission is $(ls -ld ${DISABLE_DIR_LIST}) and be Removed"
    fi

    #datanode
    restart_datanode
    #impala
    handle_impala_mount_ok
    #for NodeManager
    chmodForNodemanager
    #Elk
    handle_Elk_mount_ok

    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

    #ѶʧӲ̵ĹڵӵĿ¼б
    grep "${ALARM_DIR}" ${DISABLE_DIR_LIST} > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "${ALARM_DIR}" >> ${DISABLE_DIR_LIST}
    fi

    chown omm:wheel ${DISABLE_DIR_LIST}
    LOG "INFO" " Set ${DISABLE_DIR_LIST} files permission is $(ls -ld ${DISABLE_DIR_LIST})"
    #impala
    handle_impala_partition_lost

    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."

    #
    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    #datanode
    restart_datanode

    #for NodeManager
    chmodForNodemanager

    return 0
}

function nodemanager_chmod_dirs()
{
    local nm_dirs="$1"
    local tmp_dir=""
    local file_group=""
    local exist_parent_dir=""

    for nm_dir in ${nm_dirs//,/ }; do

        tmp_dir="$nm_dir"

        while true; do
            if [ -d "$tmp_dir" ]; then
                exist_parent_dir=$(cd "$tmp_dir"; pwd)
                break
            fi

            tmp_dir=$(dirname "${tmp_dir}")
        done

        if [ ! -d "${nm_dir}" ]; then
            mkdir -p "${nm_dir}"
        fi

        chmod 755 "${nm_dir}"
        chown omm:ficommon "${nm_dir}"
        LOG "INFO" "Set ${nm_dir} files permission is $(ls -ld ${nm_dir})"
        tmp_dir=$(cd "${nm_dir}"; pwd)

        while true; do
            tmp_dir=$(dirname "${tmp_dir}")

            if [ "${tmp_dir}" == "/" ]; then
                break
            fi

            file_group=$(stat -c "%G" "$tmp_dir")

            if [ ${#tmp_dir} -gt ${#exist_parent_dir} ]; then
                chmod 750 "${tmp_dir}"
                chown omm:ficommon "${tmp_dir}"
                LOG "INFO" "Set ${tmp_dir} files permission is $(ls -ld ${tmp_dir})"
            else
                chmod u+x "$tmp_dir"
                if [ "$file_group" == "ficommon" ]; then
                    chmod g+x "$tmp_dir"
                else
                    chmod o+x "$tmp_dir"
                fi
            fi
	    LOG "INFO" "Set ${tmp_dir} files permission is $(ls -ld ${tmp_dir})"
        done
    done
}


function chmodForNodemanager()
{
    local nmConfFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_NodeManager/etc/yarn-site.xml)
    [ -z "$nmConfFile" ] && return 0

    local nmLocalDirs=$(awk '{printf "%s", $0}' "$nmConfFile" | awk -F"yarn.nodemanager.local-dirs" '{print $2}' | awk -F"</[]*value[ ]*>" '{print $1}' | awk -F"<[ ]*value[ ]*>" '{print $2}')
    local nmLogDirs=$(awk '{printf "%s", $0}' "$nmConfFile" | awk -F"yarn.nodemanager.log-dirs" '{print $2}' | awk -F"</[]*value[ ]*>" '{print $1}' | awk -F"<[ ]*value[ ]*>" '{print $2}')

    LOG "INFO" "whoami=$(whoami), nmLocalDirs=${nmLocalDirs}, nmLogDirs:${nmLogDirs}"

    nodemanager_chmod_dirs "$nmLocalDirs"
    nodemanager_chmod_dirs "$nmLogDirs"
    nodemanager_create_cacheDirs "$nmLocalDirs"
    return 0

}

function nodemanager_create_cacheDirs()
{
    local nm_dirs="$1"
    local nm_usercache_dir=""
    local nm_filecache_dir=""

    for nm_dir in ${nm_dirs//,/ }; do

        nm_usercache_dir="${nm_dir}/usercache"
        nm_filecache_dir="${nm_dir}/filecache"
        nm_nmPrivate_dir="${nm_dir}/nmPrivate"

        if [ ! -d "${nm_usercache_dir}" ]; then
            mkdir "${nm_usercache_dir}"
        fi
        chmod 755 "${nm_usercache_dir}"
        chown omm:wheel "${nm_usercache_dir}"

        if [ ! -d "${nm_filecache_dir}" ]; then
            mkdir "${nm_filecache_dir}"
        fi
        chmod 755 "${nm_filecache_dir}"
        chown omm:wheel "${nm_filecache_dir}"

        if [ ! -d "${nm_nmPrivate_dir}" ]; then
            mkdir "${nm_nmPrivate_dir}"

        fi
        chmod 700 "${nm_nmPrivate_dir}"
        chown omm:wheel "${nm_nmPrivate_dir}"

    done
}


#ִ
main
exit $?

