#!/bin/bash

checkipmitool()
{   
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking ipmitool command."
    
    tmpstr=$(ipmitool -V)
    local retval=$?
    if [ $retval -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: check ipmitool command failed, return $retval."
        
        ##־
        log "[ERROR]" "${LINENO}" "${ip}: ipmitool command check failed. Please perform the preinstall operation."
    fi
}

checkiostat()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking iostat command."
    
    tmpstr=$(iostat)
    local retval=$?
    if [ $retval -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: check iostat command failed, return $retval."
        
        ##־
        log "[ERROR]" "${LINENO}" "${ip}: iostat command check failed. Please perform the preinstall operation."
    fi
}

