#!/bin/bash
#------------------------------------------------------------------------------
#检查内核参数zone_reclaim_mode
#------------------------------------------------------------------------------

checkZoneReclaim()
{
    log "[INFO]" "${LINENO}" "${ip}: start checking the zone_reclaim_mode."  
    ip=$1
    if [ -e "/proc/sys/vm/zone_reclaim_mode" ]
    then
        checkResult=$(cat /proc/sys/vm/zone_reclaim_mode)
        if [ "${checkResult}" -eq 0 ]
        then
            log "[ERROR_DEBUG]" "${LINENO}" "${ip}: zone_reclaim_mode is 0."
        else
            log "[ERROR]" "${LINENO}" "${ip}: The 'zone_reclaim_mode' is configured incorrectly."
        fi
    fi
        
}
