#!/bin/bash


function checkLib64()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking lib64."

    #检查/usr/lib64文件夹下是否存在libhadoop.so文件
    dirPath=/usr/lib64
    if [ -d "${dirPath}" ]
    then
        retVal=$(find "${dirPath}" -name "libhadoop*" | wc -l)
        if [ "${retVal}" -ne 0 ]
        then
            log "[ERROR]" "${LINENO}" "${ip}: The file 'libhadoop.so' exists in '/usr/lib64'."
        fi
    fi
}

