#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

###############################################################
# -----------------------------------------------------
###############################################################
declare -r OMM_USER="omm"
declare -r SCRIPT_FILE_NAME="sbin/dbom_recover.sh"
declare -r DB_CREATER="ommdba"
declare SCRIPT_FILE=""
declare SCCRIPT_HOME=""
declare ACTIVE_OMS="active"
declare STANDBY_OMS="standby"
declare CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"
declare DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
declare LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/dbdata_om_notify.log"

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_GAUSSDATA_HOME="${GAUSSDATA}"
    DISKMGT_BIGDATA_DATA_HOME="${BIGDATA_DATA_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_GAUSSDATA_HOME="$(su - omm -c 'echo $GAUSSDATA')"
    DISKMGT_BIGDATA_DATA_HOME="$(su - omm -c 'echo $BIGDATA_DATA_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

################################################################################
# Function: main
# Description: ʼû
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_parameter()
{
    local user=$(id -un)
    if [ "$user" != "${OMM_USER}" ]; then
      SCCRIPT_HOME=$(su - ${OMM_USER} -c "env" | grep CONTROLLER_HOME | cut -f 2 -d '=' | sed 's/[[:space:]]//g')
    else
      SCCRIPT_HOME=${CONTROLLER_HOME}
    fi
    
    if [ -z $SCCRIPT_HOME ]; then
      LOG "ERROR" "Get SCCRIPT_HOME=$SCCRIPT_HOME error."
      return 1
    fi
    
    SCRIPT_FILE="${SCCRIPT_HOME}/${SCRIPT_FILE_NAME}"
    LOG "INFO" "SCRIPT_FILE=${SCRIPT_FILE} ."
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"
    
    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${ALARM_DIR} is not used by dbdata_om module in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "ERROR" "Failed to judge whether ${ALARM_DIR} is used by dbdata_om module in cloud cluster."
            return 1
        fi
    fi
    
    if [ ${ALARM_ID} -eq 0 ]; then
        LOG "INFO" "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        LOG "INFO" "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            LOG "INFO" "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            LOG "INFO" "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            LOG "ERROR" "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        LOG "ERROR" "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

###############################################################
# ־
###############################################################
function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# ʵδװδʹøĿ¼1
# Parameter: 
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir=${1}
    
    if [ ! -f ${DISKMGT_BIGDATA_HOME}/om-server/om/omsetup.completed ]; then
        LOG "INFO" "Not oms node. So ${mountDir} is not used by dbdata_om module."
        return 1
    fi
    
    # ӵָʹ˴η¼Ŀ¼Ƿͬͬ˵ݻָʹ
    local dbDataPath="$(readlink -m ${DISKMGT_GAUSSDATA_HOME})"
    local currentDir="$(readlink -m ${mountDir}/dbdata_om/db)"
    
    if [ "${dbDataPath}" = "${currentDir}" ]; then
        LOG "INFO" "Manager gaussDB data path is ${dbDataPath}. So ${mountDir} is used by dbdata_om module."
        return 0
    else
        LOG "INFO" "Manager gaussDB data path is ${dbDataPath}. So ${mountDir} is not used by dbdata_om module."
        return 1
    fi
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."
    
    local haStatus="$(su - omm -c '$OMS_RUN_PATH/workspace/ha/module/hacom/script/get_harole.sh')"
    if [ "${haStatus}" !=  "${STANDBY_OMS}" ]; then
        LOG "ERROR" "Disk used by dbdata_om should be replaced on standy oms. Now this node is active oms. Please contact technical support."
        return 1
    fi
    
    #ʼ
    init_parameter
    if [  $? != 0 ]; then
        LOG "ERROR" "dbservice_recover  init_parameter failed."
        return 1
    fi

    #ִлָ
    local user=$(id -un)
    if [ "$user" = "root" ]; then
        recover_db_dir_and_config
        ret=$?
    else
        LOG "ERROR" "Operate user is not  root, please change to root."
        ret=1
    fi

    if [ $ret != 0 ]; then
       LOG "ERROR" "dbdata_om  handle_mount_ok failed."
       return 1
    fi

    #ǿֹͣݿ̣HADBͬ
    su - ${DB_CREATER} -c "gs_ctl stop -m i " >> "$LOGFILE" 2>&1

    LOG "INFO" "dbdata_om  handle_mount_ok success."
    return 0
}

################################################################################
# Function: recover_db_dir_and_config
# Description:ָݿĿ¼ļ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
recover_db_dir_and_config()
{
    local dbDataPath="$(readlink -m ${DISKMGT_GAUSSDATA_HOME}/../)"
    if [ ! -d "${dbDataPath}" ]; then
        su - ${OMM_USER} -c "mkdir ${dbDataPath}"  >> "$LOGFILE" 2>&1
        if [ $? -ne 0 ]; then
           LOG "ERROR" "Failed to mkdir ${dbDataPath} with user ${OMM_USER}."
           return 1
        fi
    fi
    
    su - ${OMM_USER} -c "chmod 770  ${dbDataPath}"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "Failed to chmod 770  ${dbDataPath} with user ${OMM_USER}."
       return 1
    fi
    
    if [ ! -d "${DISKMGT_GAUSSDATA_HOME}" ]; then
        su - ${DB_CREATER} -c "mkdir ${DISKMGT_GAUSSDATA_HOME}"  >> "$LOGFILE" 2>&1
        if [ $? -ne 0 ]; then
           LOG "ERROR" "Failed to mkdir ${DISKMGT_GAUSSDATA_HOME} with user ${DB_CREATER}."
           return 1
        fi
    fi
    
    su - ${DB_CREATER} -c "chown ${DB_CREATER}: ${DISKMGT_GAUSSDATA_HOME} -R"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "Failed to chown ${DB_CREATER}: ${DISKMGT_GAUSSDATA_HOME} -R with user ${DB_CREATER}."
       return 1
    fi
    
    su - ${DB_CREATER} -c "chmod 700 ${DISKMGT_GAUSSDATA_HOME}"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "Failed to chmod 700 ${DISKMGT_GAUSSDATA_HOME} with user ${DB_CREATER}."
       return 1
    fi
    
    local db_config_file="$DISKMGT_GAUSSDATA_HOME/postgresql.conf"
    if [ -f  "${db_config_file}" ]; then
        LOG "INFO" " ${LINENO} ${db_config_file} exists, remove and rebuild"
        su - ${DB_CREATER} -c "rm -rf  ${db_config_file}" >> "$LOGFILE" 2>&1
    fi
    
    local db_backup_config_file="$DISKMGT_BIGDATA_HOME/../Bigdata_gaussdb/workspace/gaussdb/conf_bak/postgresql.conf"
    su - ${DB_CREATER} -c "cp -r ${db_backup_config_file}  ${DISKMGT_GAUSSDATA_HOME}"  >> "$LOGFILE" 2>&1
    if [ $? != 0 ]; then
       LOG "ERROR" "cp -r ${CONTROLLER_HOME}/etc/om/${DB_CONF_FILE} ${DB_DATA_DIR} failed."
       return 1
    fi
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."

    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    return 0
}


#ִ
main
exit $?

