#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_LOG_HOME="${BIGDATA_LOG_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_LOG_HOME="$(su - omm -c 'echo $BIGDATA_LOG_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_LOG_HOME}" ]; then
    DISKMGT_BIGDATA_LOG_HOME="/var/log/Bigdata"
fi
DISK_CONFIG_DIR="${DISKMGT_BIGDATA_HOME}/tmp/disk_manager"
LOGFILE="${DISKMGT_BIGDATA_LOG_HOME}/nodeagent/scriptlog/disk_manager_notify.log"
function LOG()
{
    local log_size=0
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown omm:wheel "$LOGFILE"
    fi
    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null
    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #if logfile size is bigger than 50M, then backup it.
        mv ${LOGFILE} ${LOGFILE}_bak
        chown omm:wheel ${LOGFILE}_bak
    fi
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"

    if [ ! -d "${DISK_CONFIG_DIR}" ]; then
        mkdir -p ${DISK_CONFIG_DIR}
        chown omm:wheel ${DISK_CONFIG_DIR}
    fi
    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

function restart_nimbus()
{
    local pid=""
    #kill nimbus process, and timer will restart nimbus automatically.
    pid=$(ps -efww | grep "Ddaemon.name=nimbus" | grep java |grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find nimbus process."
        return 0
    fi
    LOG "INFO" "Kill nimbus process, pid=[${pid}]."
    sudo /bin/kill -9 ${pid}
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    # nimbus
    restart_nimbus
    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

    return 0
}

################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."

    # no process, return 0 directly
    return 0
}

################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    # nimbus
    restart_nimbus
    return 0
}


#ִ
main
exit $?

