#!/bin/bash
os_version_file="os_version.txt"
if [ ! -f ${os_version_file} ]
then
    touch ${os_version_file} 
fi

os_version_tmp=`cat ${os_version_file}`
os_version=`uname -a | awk '{print $3}'` 
echo ${os_version} > ${os_version_file}

if [ "Y${os_version_tmp}" == "Y" ] \
    || [ "${os_version_tmp}" == "${os_version}" ]
then
    exit 0 
fi

echo "`date`: last os version is ${os_version_tmp},\
      and current os version is : ${os_version}" > os_log.txt 
echo "`date`: begin to set os parameter again" >> os_log.txt

os_name=`cat /etc/os-release | grep -i "suse"`
if [ "Y${os_name}" == "Y" ]
then
    os_name="redhat"
fi

find ./ -name "*.sh" | xargs chmod u+x

cmd="${os_name}/setup.sh"
echo $cmd
swap_off=1

${cmd} -w ${swap_off}

echo "`date`: successfully to set os parameter again" >> os_log.txt

