##MRS版本若无相关补丁支持磁盘扩容，可以参照此指导文档进行磁盘扩容

###前置条件    
  1.  在MRS console界面节点管理处，使用数据盘扩容功能对相应节点云磁盘进行扩容（若节点组无数据盘扩容功能显示，可联系华为云运维支持），    
        云硬盘容量扩容成功后，按照以下操作步骤对节点磁盘分区进行扩容。
  2.  获取集群所有节点的操作用户及密码，同时各节点需要启用该用户的远程登录权限（该操作只能使用root用户）。

###操作步骤   
  1.  使用PuTTY工具以操作用户登录主管理节点。
  2.  将FusionInsight软件补丁工具包“MRS_Disk_Expand_Disks_Partition_Tool_Patch.tar.gz”上传至“/opt”目录下
  3.  执行以下命令解压压缩包
      

        cd /opt   
        tar -zvxf MRS_Disk_Expand_Disks_Partition_Tool_Patch.tar.gz    
        cd /opt/MRS_Disk_Expand_Disks_Partition_Tool_Patch    
        tar -zvxf  FusionInsight_SetupTool.tar.gz  
      
  4.   进入“/opt/MRS_Disk_Expand_Disks_Partition_Tool_Patch/FusionInsight_SetupTool/preinstall/tools/cluster”目录，按照需求编辑“cluster.ini”文件。    
       其中g_hosts只需配置扩容节点ip，没有扩容磁盘容量的节点无需在cluster.ini文件中配置。  
       “cluster.ini”配置参数说明: 
       
       
            g_hosts（必须配置）：  
                取值(举例): 192.168.10.[10-20]
                描述：需要执行操作的所有节点的IP地址。    
                     各IP地址间用“,”隔开，例如：192.168.10.10,192.168.10.11。    
                     如果IP地址连续，用“-”连接。例如：192.168.10.[10-20]。  
                     如果IP地址分段连续，连续时用“-”连接，各IP地址段间用“,”隔开，例如：192.168.10.[10-20,30-40]。    
            g_user_name:    
                取值：root       
                描述：执行操作的用户。
            g_password：
                描述：执行操作的用户对应的密码文件，默认为空。
            g_port：
                取值(举例)：22  
                描述：SSH连接端口，默认为22。
            g_timeout：
                取值(举例)：10  
                描述：SSH连接的超时时间，默认为10秒，当网络较差时可以适当增加。
            g_ip_model：
                取值(举例)：IPv4    
                描述：集群所在网络的IP地址模式。

            说明：
                1.  “g_password”默认为空，如果执行操作的所有用户的密码一致，命令执行后在界面手动输入一次密码即可。
                否则，需要在节点上手动创建一个密码文件，并将“g_password”参数设置为密码文件的全路径。
                密码文件格式如下：
                    IP地址1
                    IP地址1的密码
                    IP地址2
                    IP地址2的密码
                    ...

                2.  本地记录节点密码存在安全风险，建议采用各节点执行用户的密码保持一致的方式。如必须使用密码，请设置密码文件仅执行用户有读写权限，并在使用过后立即删除。
                密码文件必须是UNIX格式。
                密码文件的最后一行不能为空。
                密码中如果包含特殊字符，不需要转义。
                例如，创建“secret.txt”文件，内容如下：
                    10.10.37.[10-11]
                    123456!654321
                    10.10.37.12
                    123456!
 
  5.  拷贝脚本工具及所需rpm包至集群内需要磁盘分区扩容的节点。  
      命令格式：./clusterscp.sh put 源文件路径 目的路径   
      ./clusterscp.sh put /opt/MRS_Disk_Expand_Disks_Partition_Tool_Patch/expand_disks_partition_tool.sh /tmp/  
      ./clusterscp.sh put /opt/MRS_Disk_Expand_Disks_Partition_Tool_Patch/gdisk-0.8.6-5.eulerosv2r7.x86_64.rpm /tmp/  
      ./clusterscp.sh put /opt/MRS_Disk_Expand_Disks_Partition_Tool_Patch/libicu-50.1.2-15.h3.eulerosv2r7.x86_64.rpm /tmp/  
 
  6.  执行批量操作命令(磁盘分区扩容操作)。   
      命令格式：./clustercmd.sh "详细命令"   
      ./clustercmd.sh "bash /tmp/expand_disks_partition_tool.sh"  
 
  7.  查看磁盘分区是否扩容成功  
      在对应节点上执行“lsblk”查看对应的磁盘分区容量是否增加  
      在对应节点上执行“df -h”查看磁盘分区里的文件系统大小是否扩容

 
