#!/bin/bash
################################################################################
# Function: config_ipmi_r
# Description:HDרʶļάHDӱǩ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return:
# Others:
################################################################################
function config_ipmi()
{
    local fusionInsightApplianceConfig="/etc/fusionInsightAppliance"
    local productNameFusionInsight="FusionInsight"
    local ipmiName=""
    # ֻHDר̬ļ
    if [ ! -f ${fusionInsightApplianceConfig} ] ;then
        ipmiName=$(ipmitool fru print 0 |grep "Product Name" |awk -F ':' '{print$2}'|sed -e "s/^[ ]*//g" 2>/dev/null);
        if [ "${productNameFusionInsight}" == "${ipmiName}" ] ; then
           touch /etc/fusionInsightAppliance;
           chmod 644 /etc/fusionInsightAppliance
           echo ${productNameFusionInsight} > /etc/fusionInsightAppliance
        fi
    fi

    if [ -f ${fusionInsightApplianceConfig} ] ; then
        update_hardwareType
        if [ $? -ne 0 ] ; then
           return 1
        fi
    fi

   return 0
}

################################################################################
# Function: cron_ipmi
# Description:HDרӱǩ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return:
# Others:
################################################################################
function update_hardwareType()
{
 local configName=$(cat /etc/fusionInsightAppliance|sed -e "s/^[ ]*//g" 2>/dev/null)
 local ipmiName=$(ipmitool fru print 0 |grep "Product Name" |awk -F ':' '{print$2}'|sed -e "s/^[ ]*//g" 2>/dev/null)
 local finalAscii="0x46 0x75 0x73 0x69 0x6F 0x6E 0x49 0x6E 0x73 0x69 0x67 0x68 0x74"
 local productName="FusionInsight"

 if [[ "${configName}" == "${productName}" ]]&&[[ "${configName}" != "${ipmiName}" ]]; then
    ipmitool raw 0x30 0x90 0x04 0x00 0x03 0x01 0x00 0x0D ${finalAscii}
    ipmitool raw 0x30 0x90 0x04 0x00 0x06 0x01 0x00 0x0D ${finalAscii}
    ipmitool raw 0x30 0x90 0x06 0x00 0xaa
 fi
}

config_ipmi

