#!/bin/bash

checkHadoopConfigured()
{
    log "[INFO]" "${LINENO}" "${ip}: start checking the HADOOP_HOME configuration."  
    ip=$1

    checkHadoop
    if [ $? -ne 0 ]
    then 
        log "[ERROR]" "${LINENO}" "${ip}: The 'HADOOP_HOME' is configured, and other Hadoop platforms may have been installed."
    fi
}

checkHadoop()
{
    # 检查HADOOP_HOME值是否为空判断是否已安装其他HADOOP
    if [ -n "${HADOOP_HOME}" ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: The 'HADOOP_HOME' is configured:${HADOOP_HOME}."      
        return 1
    fi
    
    return 0
}
