#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/elasticsearch/esnode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi

CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"

##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_LOG_HOME="${BIGDATA_LOG_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_LOG_HOME="$(su - omm -c 'echo $BIGDATA_LOG_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_LOG_HOME}" ]; then
    DISKMGT_BIGDATA_LOG_HOME="/var/log/Bigdata"
fi

DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/elasticsearch_notify.log"

function LOG()
{
    local log_size=0
    
    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
    fi
    
    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null
    
    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
    fi
}


################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"
    
    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [[ -f ${CLOUD_FLAG_FILE} ]]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [[ ${retVal} -eq 1 ]]; then
            LOG "INFO" "${ALARM_DIR} is not used by Elasticsearch in cloud cluster. Skip to execute partition event."
            return 0
        elif [[ ${retVal} -eq 255 ]]; then
            LOG "INFO" "Failed to judge whether ${ALARM_DIR} is used by Elasticsearch in cloud cluster."
            return 1
        fi
    fi
        
    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# Parameter: 
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir=${1}
    
    # Elasticsearch ܻᲿʵҪʵжϴǷʹãʹõֱӷأǰɫûʹüһɫ
    for role in EsMaster EsNode1 EsNode2 EsNode3 EsNode4 EsNode5 EsNode6 EsNode7 EsNode8 EsNode9 EsClient
        do
            is_dir_in_use_by_role ${mountDir} ${role}
            local retVal=$?
            if [[ ${retVal} -eq 0 ]]; then
                return 0
             elif [[ ${retVal} -eq 255 ]]; then       
                return 255
            fi
        done
    
    return 1
}

is_dir_in_use_by_role()
{   
    local mountDir=${1}
    local role=${2}
   # Ŀ¼ļ·etc_UPDATEDڣʹetc_UPDATED·µļ
    local currentConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_${role}/etc/elasticsearch.yml
    local updateConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_${role}/etc_UPDATED/elasticsearch.yml
        
    local configFile=""
    if [[ -f $(echo ${updateConfigFile}) ]]; then
        configFile=${updateConfigFile}
    elif [[ -f  $(echo ${currentConfigFile}) ]]; then
        configFile=${currentConfigFile}
    else
        LOG "INFO" "Conf file for ${role} does not found. So ${mountDir} is not used by ${role}."
        return 1 
    fi
    
    # ļлȡĿ¼Ӧֵδȡش255
    local dataDirs=$(su - omm -c "grep 'path.data' ${configFile}" | awk '{print $2}')
    if [[ -z ${dataDirs} ]]; then
        LOG "ERROR" "Can not get Elasticsearch config item path.data in ${configFile}."
        return 255
    fi
    
    # жϴ˴η¼ӦĹصĿ¼ǷĿ¼Сڣ˵ʵʹˣ0δʹã1
    # Elastisearch ڹض̵ĳ
    echo ${dataDirs} | awk -F ',' '{for(i=0;i<NF;i++) {print $i}}' | grep -qw ${mountDir}
    if [[ $? -eq 0 ]]; then
        LOG "INFO" "Match ${mountDir} in config value ${dataDirs}. So ${mountDir} is used by ${role}."
        return 0
    else
        LOG "INFO" "Can not match ${mountDir} in config value ${dataDirs}. So ${mountDir} is not used by ${role}."
        return 1
    fi
}


function restart_es()
{
    local pid=""
    if [[ -f ${CLOUD_FLAG_FILE} ]]; then
        pid=$(ps -efww | grep 'org.elasticsearch.bootstrap.Elasticsearch' | grep java |grep -v grep | awk '{print $2}' |xargs echo)
        LOG "INFO" "In cloud cluster , kill all es process, pid=[${pid}]."
        /bin/kill -9 ${pid}
        return 0
    fi
    ##find es process and kill
    esname=${ALARM_DIR##*/}
    if [ "${esname}" == "esmaster" ]; then
        esname="EsMaster"
    elif [[ ${esname} =~ esnode[1-9] ]]; then
        esname="EsNode"${esname:6}
    else
        LOG "INFO" "It not a es data path."
        return 0
    fi
    LOG "INFO" "ES node is ${esname}"
    pid=$(ps -efww | grep ${esname} | grep java |grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find es process."
        return 0
    fi

    LOG "INFO" "Kill es process, pid=[${pid}]."
    /bin/kill -9 ${pid}
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    restart_es
    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."
    
    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."
    
    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."
   
    restart_es
    return 0
}


#ִ
main
exit $?

